/************************************************************************
Programma pelaths	: AirportManagement.c
Syggrafeas			: Lougiakis Christos
Skopos				: skeleton main for askhsh 3
*************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "TSEvr.h"
#include "Evretirio.h"

#define MAXSIZE 3000

int main(int argc, char *argv[])
{ int i, j, k;
  FILE *finp, *foutp, *ftime;
  char tempstr[200];
  EvrPtr E;
  keyType key;
  TStoixeiouOther Other;

  clock_t t1, t2, tmp2;   /* Declare time variables */
  double ratio = 1./CLOCKS_PER_SEC;

  strcpy( Other.country, "NULL");   /*arxikopoiisi dedomenon gia proti eisagogi*/
  strcpy( Other.ICAO, "NULL");
  
  E=Evr_dimiourgia(MAXSIZE);    /*dimiourgia euretiriou*/
  
  ftime=fopen("Data Files/time.txt","w");
  printf("Doste 1 gia Random arxeio, 2 gia Sorted:");   /*epilogi gia random i sorted arxeio eisodou*/
  scanf("%d",&i);
  switch (i){
		case 1:
  			finp=fopen("Data Files/IATAcodesRandom.txt","r");
  			fprintf( ftime, "Random arxeio:\n");
  			break;
		case 2:
		  	finp=fopen("Data Files/IATAcodesSorted.txt","r");
		  	fprintf( ftime, "Sorted arxeio:\n");
		  	break;
  }
  
  t1 = clock();  /* Record the start time */
  j=1;
  for (i=0; i<MAXSIZE; i++){
  	if (TSEvr_readKeyValue ( finp,  &key )==0)
  	    break;
  	Evr_Insert( E, key, Other); /*eisagogi kleidiou sto dentro*/
  	if ( i == ((512*j)-1) ){
    	tmp2=clock();   /* Record the end time */
    	/* Print out the difference, converting it to seconds */
   		fprintf( ftime, "\nXronos gia na eisaxthoun %d stoixeia = %g seconds\n", (512*j)-1, ratio*(long)tmp2 - ratio*(long)t1 );
    	j=j*2;
	}
  }
  t2=clock();   /* Record the end time */
  /* Print out the difference, converting it to seconds */
  fprintf( ftime, "\nSynolikos xronos eisagogis %d stoixeion = %g seconds\n", i, ratio*(long)t2 - ratio*(long)t1 );
  
  fclose(finp);

  finp=fopen("Data Files/ICAO-IATAbyCountry.txt","r");
  
  t1 = clock();  /* Record the start time */
  j=1;
  k=0;
  while ( fgets( tempstr, 200, finp)!=NULL ){
	if ( tempstr[0]=='@'){
		strncpy( Other.country, strtok( tempstr, "@	"), 14);/*an anaferetai i xora tin pernaei stin metavliti enimerosis*/
		Other.country[14]='\0';
	}
	else
	    if ( tempstr[5]=='(' ){ /*an yparxei kodikos kleidiou pros enimerosi*/
            strncpy( Other.ICAO, strtok( tempstr, " "), 4);/*pernaei kai ton kodiko ICAO stin metavliti enimerosis*/
            strncpy( key, strtok( NULL, " ()"), 3);/*pernaei stin metavliti key to kleidi pou theloume na enimerothoun ta data tou*/
            Evr_ChangeData( E, key, Other);/*enimerosi dedomenon me ta data kai to key pou perasame proigoumenos*/
            k++;
            if ( k == ((512*j)-1) ){
    			tmp2=clock();   /* Record the end time */
    			/* Print out the difference, converting it to seconds */
   				fprintf( ftime, "\nXronos enimerosis %d stoixeion = %g seconds\n", (512*j)-1, ratio*(long)tmp2 - ratio*(long)t1 );
    			j=j*2;
			}
		}
  }
  t2=clock();   /* Record the end time */
  /* Print out the difference, converting it to seconds */
  fprintf( ftime, "\nSynolikos xronos enimerosis %d stoixeion = %g seconds\n", k, ratio*(long)t2 - ratio*(long)t1 );
  
  fclose(finp);

  foutp=fopen("Data Files/out.txt","w");
  
  t1 = clock();  /* Record the start time */
  Evr_PrintAll( E, foutp);  /*ektyposi sto arxeio out.txt tou apotelesmatos tis eisagogis kai enimerosis*/
  t2=clock();   /* Record the end time */
  /* Print out the difference, converting it to seconds */
  fprintf( ftime, "\nSynolikos xronos ektyposis %d stoixeion = %g seconds\n", i, ratio*(long)t2 - ratio*(long)t1 );
  
  fclose(foutp);
  fclose(ftime);

  Evr_katastrofi(&E);   /*katastrofi euretiriou*/

  
  system("PAUSE");
  return 0;
}

