#include "Evretirio.h"
#define Simple 0 /* 0 for AVL - any other integer for Simple  */

#if (Simple)
   #include "BST\ch8_BSTpointer.h" /* gia Simple Ylopoihsh */
#else
   #include "AVL\ch8_AVLpointer.h" /* gia AVL Ylopoihsh */
#endif


/* Oi diafores tvn ylopoihsevn Simple kai AVL einai mikres - mporeite na xrhsimopoihsete 
   thn parapanv domh #if ... #else ...#endif gia na diaforopihsete tis dyo ylopoihseis  */

struct EvrNode{
       TStoixeiouOther *DataArray; /* array of size MaxSize */
       int LastElem;              /* index of last element in array */
       typos_deikti TreeRoot;     /* Root of Tree */
};

void endodiataksi(typos_deikti riza, EvrPtr E, FILE *out);  /*orismos voithitikis synartisis*/

EvrPtr Evr_dimiourgia(int MaxSize){
/* 	Oi diafores tvn ylopoihsevn Simple kai AVL einai mikres - mporeite na xrhsimopoihsete
	thn parapanv domh #if ... #else ...#endif
	See following example	*/
	EvrPtr E;   
	E=malloc(sizeof(struct EvrNode));   /*dimiourgia kombou euretirou*/
	E->DataArray=malloc(MaxSize*sizeof(TStoixeiouOther));   /*desmeusi pinika megethous MAXSIZE gia ta dedomena*/
	E->LastElem=0;  /*arxikopoiisi tou deikti teleutaiou stoixeiou tou pinaka*/
#if (Simple)
   printf("simple-out\n");
   Tree_dimiourgia(&E->TreeRoot);   /*dimiourgia aplou dentrou*/
#else   
    printf("AVL-out\n");
    AVLTree_dimiourgia(&E->TreeRoot);   /*/*dimiourgia AVL dentrou*/
#endif
	return E;

}

int Evr_Insert(EvrPtr E, keyType key, TStoixeiouOther Data){
	int error, ypsilotero;
	TStoixeiouDDA stoixeio;
	TSEvr_setValue(&E->DataArray[E->LastElem], Data);/*perniountai ta dedomena stin teleutaia diathesimi thesi tou pinaka*/
	TSEvr_setKeyValue( &stoixeio.key, key); /*ftiaxoume ena TStoixeiouDDA na periexei to kleidi*/
	stoixeio.arrayIndex=E->LastElem;    /*kai ti thesi pou vriskontai ta dedomena tou*/
#if (Simple)        /*sti synexeia eisagetai sto dentro*/
   	Tree_eisagogi(&E->TreeRoot, stoixeio, &error);
#else
    AVLTree_eisagogi(&E->TreeRoot, stoixeio, &ypsilotero, &error);
#endif
	E->LastElem++;  /*telos, auxanetai o deiktis teleutaiou stoixeiou tou pinaka*/
	return 1;
}

int Evr_ChangeData(EvrPtr E, keyType key, TStoixeiouOther Data){
	int found;
	TStoixeiouDDA stoixeio;
	typos_deikti deiktis;
	TSEvr_setKeyValue( &stoixeio.key, key);	/*ftiaxoume ena TStoixeiouDDA na periexei to kleidi*/
#if (Simple)        /*kanoume anazitisi sto dentro me vasi auto to kleidi*/
   	Tree_anazitisi( E->TreeRoot, stoixeio, &deiktis, &found);
#else
    AVLTree_anazitisi( E->TreeRoot, stoixeio, &deiktis, &found);
#endif
	if (found==1){  /*an vrethike pernietai k i thesi tou ston pinaka sto TStoixeiouDDA*/
#if (Simple)
   	Tree_periexomeno( deiktis, &stoixeio);
#else
    AVLTree_periexomeno( deiktis, &stoixeio);
#endif
        TSEvr_setValue( &E->DataArray[stoixeio.arrayIndex], Data);  /*enimeronontai ta dedomena tou ston pinaka*/
	}
	return 1;
}

int Evr_PrintAll(EvrPtr E, FILE *out){
	endodiataksi( E->TreeRoot, E, out );    /*kaleitai i synartisi endodiataksi*/
	return 1;
}

void endodiataksi(typos_deikti riza, EvrPtr E, FILE *out){/* Anadromiko ypoprograma. Diatrexei me endodiatetagmeni diadromi ena dyadiko dentro*/
	typos_deikti paidi;
	TStoixeiouDDA stoixeio;
	int error, i;
#if (Simple)
   	i=Tree_keno(riza);
#else
    i=AVLTree_keno(riza);
#endif
	if (!i){
#if (Simple)
   	Tree_apaidi( riza, &paidi, &error);
#else
    AVLTree_apaidi( riza, &paidi, &error);
#endif
		endodiataksi( paidi, E, out); /*aristero ypodentro*/
#if (Simple)
   	Tree_periexomeno( riza, &stoixeio);
#else
    AVLTree_periexomeno( riza, &stoixeio);
#endif
		TSEvr_writeKeyValue( out, stoixeio.key);/*Episkepsi tis rizas*/
		TSEvr_writeValue( out, E->DataArray[stoixeio.arrayIndex]);/*Episkepsi tis rizas*/
#if (Simple)
   	Tree_dpaidi( riza, &paidi, &error);
#else
    AVLTree_dpaidi( riza, &paidi, &error);
#endif
		endodiataksi( paidi, E, out); /*deksi ypodentro*/
	}
}

int Evr_katastrofi(EvrPtr *E){
	free((*E)->DataArray);  /*eleftheronetai arxika o pinakas*/
#if (Simple)    /*meta to dentro kalontas tin antistoixi synartisi*/
   	Tree_katastrofi(&(*E)->TreeRoot);
#else
    AVLTree_katastrofi(&(*E)->TreeRoot);
#endif
	free(*E);   /*kai telos o komvos*/
	*E=NULL;
	return 1;
}
